import 'dart:async';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:sadad_payment_flutter/apputils/appassets.dart';
import 'package:sadad_payment_flutter/apputils/appdialogs.dart';
import 'package:sadad_payment_flutter/model/creditcardsettingsmodel.dart';
import 'package:sadad_payment_flutter/model/sendOtpModel.dart';
import 'package:sadad_payment_flutter/sadad_payment_flutter.dart';
import 'package:sadad_payment_flutter/services/appservices.dart';

class MainPageController extends GetxController {
  final sadadPayForm = GlobalKey<FormState>();

  final creditCardForm = GlobalKey<FormState>();
  final creditCardHolderForm = GlobalKey<FormState>();
  final creditCardNumberForm = GlobalKey<FormState>();
  final expiryValidityForm = GlobalKey<FormState>();
  final cvvForm = GlobalKey<FormState>();
  FocusNode creditCardHolderFocus = FocusNode();

  TextEditingController cardHolderNameController = TextEditingController();
  TextEditingController cardNumberController = TextEditingController();
  TextEditingController expiryController = TextEditingController();
  TextEditingController cvvController = TextEditingController();
  TextEditingController sadadPayCellNumberController = TextEditingController();
  TextEditingController sadadPayPasswordController = TextEditingController();
  TextEditingController sadadPayOTPController = TextEditingController();
  PaymentType selectedPaymentMethod = PaymentType.creditCard;
  bool rememberMe = false;
  bool isObscure = true;
  String token = "";
  List<CreditCardSettingsModel> creditCardSettingsModel = [];
  String credit_card_bankpage_type = "";
  String is_american_express = "";
  String is_cybersourse_visa = "";
  String is_cybersourse_mastercard = "";
  bool isLoading = true;
  bool sadadPayOTPSent = false;
  RxInt counter = 59.obs;
  Timer? timer;
  RxString cardType = "".obs;
  SendOtpModel? sendOtpModel;

  initOTPCounter() async {
    timer = Timer.periodic(const Duration(seconds: 1), (timer) {
      counter--;
      if (counter.value < 1) {
        timer.cancel();
      }
    });
  }

  @override
  void onInit() {
    // TODO: implement onInit
    super.onInit();
    // init();
    creditCardHolderFocus.addListener(() {
      if (creditCardHolderFocus.previousFocus()) {
        creditCardHolderForm.currentState!.validate();
      }
    });
  }

  String getCardType(String cardNumber) {
    print("cardNumber ${cardNumber}");
    cardNumber = cardNumber.replaceAll(" ", "");
    if (cardNumber.contains(RegExp(r'^(5[1-5][0-9]{4}|677189)[0-9]{5,}$'))) {
      return "Mastercard";
    } else if (cardNumber.contains(RegExp(r'^4[0-9]{6,}([0-9]{3})?$'))) {
      return "Visa";
    } else if (cardNumber.contains(RegExp(r'^3[47][0-9]{5,}$'))) {
      return "Amex";
    } else if (cardNumber.contains(RegExp(r'^(36|38|30[0-5])'))) {
      return "DINERS_CLUB";
    } else if (cardNumber.contains(RegExp(r'^(5018|5020|5038|5[6-9]|6020|6304|6703|6759|676[1-3])'))) {
      return "MAESTRO";
    } else if (cardNumber.contains(RegExp(r'^(?:2131|1800|35\d{3})\d{11}$'))) {
      return "JCB";
    } else if (cardNumber.contains(RegExp(r'^65[4-9][0-9]{13}|64[4-9][0-9]{13}|6011[0-9]{12}|(622(?:12[6-9]|1[3-9][0-9]|[2-8][0-9][0-9]|9[01][0-9]|92[0-5])[0-9]{10})$'))) {
      return "Discover Card";
    } else if (cardNumber.contains(RegExp(r'^(62[0-9]{14,17})$'))) {
      return "Union Pay Card";
    } else if (cardNumber.contains(RegExp(r'^6(?!011)(?:0[0-9]{14}|52[12][0-9]{12})$'))) {
      return "Rupay";
    }
    return "";
  }

  String getImagePath(String cardType) {
    if (cardType == "Mastercard") {
      return AssetPath.masterCard;
    } else if (cardType == "Visa") {
      return AssetPath.visa;
    } else if (cardType == "Amex") {
      return AssetPath.americanExpress;
    } else {
      return "";
    }
  }

// Future<void> init() async {
//   creditCardSettingsModel = await AppServices.getCreditCardSetting(token: token);
//   creditCardSettingsModel.forEach((element) {
//     if (element.key == "credit_card_bankpage_type") {
//       credit_card_bankpage_type = element.value ?? "";
//     } else if (element.key == 'is_american_express') {
//       is_american_express = element.value ?? "";
//     } else if (element.key == 'is_cybersourse_visa') {
//       is_cybersourse_visa = element.value ?? "";
//     } else if (element.key == 'is_cybersourse_mastercard') {
//       is_cybersourse_mastercard = element.value ?? "";
//     }
//   });
// }
}
